import { type PropType } from 'vue';
import type { AllItems, Item, OnFocusHook, OnSelectHook, OnUnfocusHook } from './types';
export declare type SetupFunctionContext = {
    focusNext(): void;
    focusPrevious(): void;
    clearFocus(): void;
    setFocusByKey(key: string): void;
    setFocusByIndex(index: number): void;
    onSelect(fn: OnSelectHook): void;
    onFocus(fn: OnFocusHook): void;
    onUnfocus(fn: OnUnfocusHook): void;
    getItemMetaDataByKey(key: string): unknown;
    getSelectableItemCount(): number;
    getSelectableItems(): Item[];
    selectFocusedElement(): void;
    getItemElementByKey(key: string): HTMLElement | undefined;
    getItemElementByIndex(index: number): HTMLElement | undefined;
    scrollToFocusedElement(options?: ScrollIntoViewOptions): void;
    getFocusedItemElement(): HTMLElement | undefined;
};
export interface Props {
    noWrapperElement: boolean;
    items: AllItems[];
    onSelect: (metaData: unknown) => void;
    setup: (context: SetupFunctionContext) => void;
}
declare const _default: import("vue").DefineComponent<{
    noWrapperElement: {
        type: PropType<boolean>;
        default: boolean;
    };
    items: {
        type: PropType<AllItems[]>;
        default: () => any[];
    };
    setup: {
        type: PropType<(context: SetupFunctionContext) => void>;
        default: any;
    };
}, {
    flattenedItems: import("vue").ComputedRef<(Item | import("./types").CustomItem)[]>;
    selectableItems: import("vue").ComputedRef<Item[]>;
    focusNext: () => void;
    focusPrevious: () => void;
    isFocused: (key: string) => boolean;
    setFocusByKey: (key: string) => void;
    selectItem: (queryKey?: string) => void;
    saveSelectableItemElement: (key: string, element: HTMLElement) => any;
}, unknown, {}, {}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, {
    select: (metaData: unknown) => void;
}, string, import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps, Readonly<import("vue").ExtractPropTypes<{
    noWrapperElement: {
        type: PropType<boolean>;
        default: boolean;
    };
    items: {
        type: PropType<AllItems[]>;
        default: () => any[];
    };
    setup: {
        type: PropType<(context: SetupFunctionContext) => void>;
        default: any;
    };
}>> & {
    onSelect?: (metaData: unknown) => any;
}, {
    noWrapperElement: boolean;
    items: AllItems[];
    setup: (context: SetupFunctionContext) => void;
}>;
export default _default;
