import type { Component } from 'vue';
import type { AllItems, CustomItem, Item, ItemGroup } from './types';
export declare function itemGroup(items: ItemGroup['items'], options?: Omit<ItemGroup, 'type' | 'key' | 'items'>): ItemGroup;
export declare function item(data: Item['metaData'], options?: Omit<Item, 'type' | 'key' | 'metaData'>): Item;
export declare function customItem(data: CustomItem['metaData'], options: Omit<CustomItem, 'type' | 'key' | 'metaData'>): CustomItem;
export declare function isItemGroup(value: unknown): value is ItemGroup;
export declare function isItem(value: unknown): value is Item;
export declare function isCustomItem(value: unknown): value is CustomItem;
export declare function isComponent(value: unknown): value is Component;
export declare const getFlattenedItems: (items: AllItems[], seenItems?: (Item | CustomItem)[]) => (Item | CustomItem)[];
